/**
 * 
 */
package org.gcube.portlets.user.td.expressionwidget.client.rpc;



import org.gcube.portlets.user.td.gwtservice.shared.exception.TDGWTServiceException;
import org.gcube.portlets.user.td.gwtservice.shared.tr.column.FilterColumnSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.column.ReplaceColumnByExpressionSession;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;

/**
 * 
 * Implements the basic interfaces generate and submit Expression on service.
 * 
 * <p>
 * Allows:  
 * <ul>
 * <li>Generate Expression</li>
 * <ul>
 * </p>
 * 
 * @author "Giancarlo Panichi" <a
 *         href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a>
 * 
 */
@RemoteServiceRelativePath("ExpressionService")
public interface ExpressionService extends RemoteService {

	/**
	 * Submit Column Filter Operation
	 * 
	 * @param columnFilterSession
	 * @throws ExpressionServiceException
	 */
	public String startFilterColumn(FilterColumnSession filterColumnSession) throws TDGWTServiceException;
	
	
	public String startReplaceColumnByExpression(ReplaceColumnByExpressionSession replaceColumnByExpressionColumnSession) throws TDGWTServiceException;
	
	
	

}
